Attribute VB_Name = "MdlMacro"
Option Explicit
'Public Declare Sub lsm Lib "lsm.dll" (ByRef X As Any, ByRef y As Any, ByVal offset As Long, ByVal sz As Long, ByRef a As Double, ByRef B As Double)

'*****************************************************
' Product Min/Max frequency
'*****************************************************
Public Const R3755A_MIN_FREQ As Double = 10000#         'Min  10kHz frequency (R3755A)
Public Const R3755A_MAX_FREQ As Double = 300000000#     'Max 300MHz frequency (R3755A)
Public Const R3760_MIN_FREQ As Double = 300000000#      'Min 300MHz frequency (R3760)
Public Const R3760_MAX_FREQ As Double = 6000000000#     'Max   6GHz frequency (R3760)
'*****************************************************
Public Const StimFRQ As Integer = 0                     'Unit Index Freq START/STOP/Center
Public Const StimSPN As Integer = 1                     'Unit Index Freq SPAN
Public Const StimMKR As Integer = 2                     'Unit Index Freq Marker
'*****************************************************
'  Marker refarence type define
'*****************************************************
Public Const MKR_REF_POINT As Integer = 0               ' Marker refarence point type
Public Const MKR_REF_FREQ As Integer = 1                ' Marker refarence frequency type
'*****************************************************
'  Display format type define
'*****************************************************
Public Const FmtTypeLogMg As Integer = 0                ' LogMag  display type
Public Const FmtTypePolar As Integer = 1                ' Polar   display type
Public Const FmtTypeSmith As Integer = 2                ' Smith   display type
Public Const FmtTypeDelay As Integer = 3                ' Delay   display type
Public Const FmtTypeSwr As Integer = 4                  ' SWR    display type
Public Const FmtTypeReal As Integer = 5                 ' Real    display type
Public Const FmtTypeImag As Integer = 6                 ' Imag    display type
Public Const FmtTypeOverlap As Integer = 7              ' Overlap display type
'*****************************************************
'  Check Box display type
'*****************************************************
Public Const ChkTypeLogMg As Integer = FmtTypeLogMg     ' LogMag  display type
Public Const ChkTypePolar As Integer = FmtTypePolar     ' Polar   display type
Public Const ChkTypeSmith As Integer = FmtTypeSmith     ' Smith   display type
Public Const ChkTypeDelay As Integer = FmtTypeDelay     ' Delay   display type
Public Const ChkTypeSwr As Integer = FmtTypeSwr         ' SWR    display type
Public Const ChkTypeReal As Integer = FmtTypeReal       ' Real    display type
Public Const ChkTypeImag As Integer = FmtTypeImag       ' Imag    display type
'*****************************************************
' Ini File access
'*****************************************************
Public Const INI_FILE_RW_FORMAT_LOGAMG As Integer = (FmtTypeLogMg + 1)
Public Const INI_FILE_RW_FORMAT__POLAR As Integer = (FmtTypePolar + 1)
Public Const INI_FILE_RW_FORMAT__SMITH As Integer = (FmtTypeSmith + 1)
Public Const INI_FILE_RW_FORMAT__DELAY As Integer = (FmtTypeDelay + 1)
Public Const INI_FILE_RW_FORMAT____SWR As Integer = (FmtTypeSwr + 1)
Public Const INI_FILE_RW_FORMAT___REAL As Integer = (FmtTypeReal + 1)
Public Const INI_FILE_RW_FORMAT___IMAG As Integer = (FmtTypeImag + 1)
Public Const INI_FILE_RW_FORMATOVERLAP As Integer = (FmtTypeOverlap + 1)
'*****************************************************
' format overlap type define
'*****************************************************
Public Const INI_FILE_RW_OVRLAP_NOT_DISP As Integer = &H0
Public Const INI_FILE_RW_OVRLAP_LOGMAG As Integer = &H1
Public Const INI_FILE_RW_OVRLAP__POLAR As Integer = &H2
Public Const INI_FILE_RW_OVRLAP__SMITH As Integer = &H4
Public Const INI_FILE_RW_OVRLAP__DELAY As Integer = &H8
Public Const INI_FILE_RW_OVRLAP____SWR As Integer = &H10
Public Const INI_FILE_RW_OVRLAP___REAL As Integer = &H20
Public Const INI_FILE_RW_OVRLAP___IMAG As Integer = &H40
'*****************************************************
' The saved valid data type
'*****************************************************
Public Const RD_NON____DATA As Integer = &H0
Public Const RD_LOGMAG_DATA As Integer = &H1
Public Const RD_POLAR__DATA As Integer = &H2
Public Const RD_SMITH__DATA As Integer = &H4
Public Const RD_DELAY__DATA As Integer = &H8
Public Const RD_SWR____DATA As Integer = &H10
Public Const RD_REAL___DATA As Integer = &H20
Public Const RD_IMAG___DATA As Integer = &H40
'*****************************************************
'  Unit
'*****************************************************
Public Const Unit_g As Single = 1000000000#             ' 1E+9  = Giga
Public Const Unit_mega As Single = 1000000#             ' 1E+6  = Mega
Public Const Unit_k As Single = 1000#                   ' 1E+3  = Kilo
Public Const Unit_s As Single = 1                       ' 1     = s
Public Const Unit_m As Single = 0.001                   ' 1E-3  = m
Public Const Unit_u As Single = 0.000001                ' 1E-6  = 
Public Const Unit_n As Single = 0.000000001             ' 1E-9  = n
Public Const Unit_p As Single = 0.000000000001          ' 1E-12 = p
Public Const Unit_f As Single = 0.000000000000001       ' 1E-15 = f
'*****************************************************
Public Const Multiple_g As Single = 0.000000001         ' 1E-9 = Giga
Public Const Multiple_mega As Single = 0.000001         ' 1E-6 = Mega
Public Const Multiple_k As Single = 0.001               ' 1E-3 = Kilo
Public Const Multiple_s As Single = 1                   ' 1 = s
Public Const Multiple_m As Single = 1000#               ' 1E+3
Public Const Multiple_mm As Single = 1000#              ' 1E+3
Public Const Multiple_u As Single = 1000000#            ' 1E+6
Public Const Multiple_n As Single = 1000000000#         ' 1E+9
Public Const Multiple_p As Single = 1000000000000#      ' 1E+12
Public Const Multiple_f As Single = 1E+15               ' 1E+15
'*****************************************************
Public Const Round_g As Single = 0.0000000005           ' 1E-10
Public Const Round_mega As Single = 0.0000005           ' 1E-7
Public Const Round_m As Single = 0.0005                 ' 1E-4
'*****************************************************
Public Const fGHz$ = "#0.000000#"                       ' 0.1 Hz resolution
Public Const fMHz$ = "#0.000000#"                       ' 0.1 Hz resolution
Public Const fkHz$ = "#0.000000#"                       ' 0.1 Hz resolution
Public Const fHz$ = "# ### ##0.0000000#"                ' 1e-7 Hz resolution
'*****************************************************
Public Const MkrfGHzfkHz$ = "#0.000000000000000#"       ' 0.000 000 001 GHz = 1Hz resolution
Public Const MkrfMHzfkHz$ = "#0.000000000#"             ' 0.000 001 MHz     = 1Hz resolution
Public Const MkrfkHzfkHz$ = "#0.000#"                   ' 0.001 kHz         = 1Hz resolution
'*****************************************************
Public Const MkrfGHzfmHz$ = "#0.000000000000#"          ' 0.000 000 000 001 GHz = 1mHz resolution
Public Const MkrfMHzfmHz$ = "#0.000000000#"             ' 0.000 000 001 MHz     = 1mHz resolution
Public Const MkrfkHzfmHz$ = "#0.000000#"                ' 0.000 001 kHz         = 1mHz resolution
Public Const MkrfHzfmHz$ = "#0.000#"                    ' 0.001 Hz              = 1mHz resolution
'*****************************************************
Public Const cnt_FILE_NOT_RE As Integer = 0             ' intFileRecall : Not Recall
Public Const cnt_FILE_RECALL As Integer = 1             ' intFileRecall : Recall
'*****************************************************
Public Const cnt_FILE_NOT_SV As Integer = 0             ' intFileRecall : Not Saving
Public Const cnt_FILE_SAVING As Integer = 1             ' intFileRecall : Saving
'*****************************************************
'  Scale Limit
'*****************************************************
Public Const LOG_RFV_MAX As Single = 999.999            'Logmag Scale Ref Value Max
Public Const LOG_RFV_MIN As Single = -999.999           'Logmag Scale Ref Value Min
Public Const LOG_DIV_MAX As Single = 200                'Logmag Scale Division Max
Public Const LOG_DIV_MIN As Single = 0.001              'Logmag Scale Division Min
Public Const LOG_RFP_MAX As Single = 100                'Logmag Scale Ref Position Max
Public Const LOG_RFP_MIN As Single = 0                  'Logmag Scale Ref Position Min
'*****************************************************
Public Const PHS_RFV_MAX As Single = 720                'Phase Scale Ref Value Max
Public Const PHS_RFV_MIN As Single = -720               'Phase Scale Ref Value Min
Public Const PHS_DIV_MAX As Single = 200                'Phase Scale Division Max
Public Const PHS_DIV_MIN As Single = 0.01               'Phase Scale Division Min
Public Const PHS_RFP_MAX As Single = LOG_RFP_MAX        'Phase Scale Ref Position Max
Public Const PHS_RFP_MIN As Single = LOG_RFP_MIN        'Phase Scale Ref Position Min
'*****************************************************
Public Const DEL_RFV_MAX As Single = 999999999999.999   'Delay Scale Ref Value Max
Public Const DEL_RFV_MIN As Single = -999999999999.999  'Delay Scale Ref Value Min
Public Const DEL_DIV_MAX As Single = 500000000000#      'Delay Scale Division Max
Public Const DEL_DIV_MIN As Single = 0.000000000001     'Delay Scale Division Min
Public Const DEL_RFP_MAX As Single = LOG_RFP_MAX        'Delay Scale Ref Position Max
Public Const DEL_RFP_MIN As Single = LOG_RFP_MIN        'Delay Scale Ref Position Min
'*****************************************************
Public Const SWR_RFV_MAX As Single = 999999999          'Swr Scale Ref Value Max
Public Const SWR_RFV_MIN As Single = -999999999         'Swr Scale Ref Value Min
Public Const SWR_DIV_MAX As Single = 5000000000#        'Swr Scale Division Max
Public Const SWR_DIV_MIN As Single = 0.0000000001       'Swr Scale Division Min
Public Const SWR_RFP_MAX As Single = LOG_RFP_MAX        'Swr Scale Ref Position Max
Public Const SWR_RFP_MIN As Single = LOG_RFP_MIN        'Swr Scale Ref Position Min
'*****************************************************
Public Const RE__RFV_MAX As Single = 999999999          'Real Scale Ref Value Max
Public Const RE__RFV_MIN As Single = -999999999         'Real Scale Ref Value Min
Public Const RE__DIV_MAX As Single = 5000000000#        'Real Scale Division Max
Public Const RE__DIV_MIN As Single = 0.0000000001       'Real Scale Division Min
Public Const RE__RFP_MAX As Single = LOG_RFP_MAX        'Real Scale Ref Position Max
Public Const RE__RFP_MIN As Single = LOG_RFP_MIN        'Real Scale Ref Position Min
'*****************************************************
Public Const IM__RFV_MAX As Single = 999999999          'Imag Scale Ref Value Max
Public Const IM__RFV_MIN As Single = -999999999         'Imag Scale Ref Value Min
Public Const IM__DIV_MAX As Single = 5000000000#        'Imag Scale Division Max
Public Const IM__DIV_MIN As Single = 0.0000000001       'Imag Scale Division Min
Public Const IM__RFP_MAX As Single = LOG_RFP_MAX        'Imag Scale Ref Position Max
Public Const IM__RFP_MIN As Single = LOG_RFP_MIN        'Imag Scale Ref Position Min
'*****************************************************
' Trace Color Select Number
'*****************************************************
Public Const TRACE_COLOR__ACT As Long = 0               'Active Trace Color
Public Const TRACE_COLOR_GRDN As Long = 1               'Grid Color
Public Const TRACE_COLOR_GRDB As Long = 2               'Grid bold Color
Public Const TRACE_COLOR_MEM1 As Long = 3               'Memory 1 Trace Color
Public Const TRACE_COLOR_MEM2 As Long = 4               'Memory 2 Trace Color
Public Const TRACE_COLOR_MEM3 As Long = 5               'Memory 3 Trace Color
'*****************************************************
' Marker Color Select Number
'*****************************************************
Public Const MKR_COLOR___ACT As Long = 0               'Active Marker Color
Public Const MKR_COLOR_NOACT As Long = 1               'Not Active Marker Color
Public Const MKR_L_COLOR_ACT As Long = 0               'Active Trace List Color
Public Const MKR_L_COLOR_MEM As Long = 1               'Memory Trace List Color
'*****************************************************
Public Const MEM_TRC_CLEAR As Integer = 0               'Memory Trace Clear
Public Const MEM_TRC_SAVE As Integer = 1                'Memory Trace Save
'*****************************************************
Public Const MEM_TRC_DSP_OFF As Integer = 0             'Memory Trace display off
Public Const MEM_TRC_DSP_ON As Integer = 1              'Memory Trace display on
'*****************************************************
Public Const MKR_LIST_X1 As Integer = 100               'Marker display position x1
Public Const MKR_LIST_X2 As Integer = 3200              'Marker display position x2
Public Const MKR_LIST_X3 As Integer = 4400              'Marker display position x3
Public Const MKR_LIST_X4 As Integer = 5600              'Marker display position x4
'*****************************************************
'Extended SW-BOX type
'*****************************************************
Public Const SWBOX_NONC As Long = 0                      ' Non Connect
Public Const SWBOX_SP4T As Long = 15                     ' SP4T(A170009)
Public Const SWBOX_DPDT As Long = 14                     ' DPDT(A170010)
Public Const SWBOX_TYPE_NONC As String = "-------"       ' Non Connect
Public Const SWBOX_TYPE_SP4T As String = "A170009"       ' SP4T(A170009)
Public Const SWBOX_TYPE_DPDT As String = "A170010"       ' DPDT(A170010)

Public Const SP4T_PORT1 As Long = 0                      ' PORT1 SP4T(A170009)
Public Const SP4T_PORT2 As Long = 1                      ' PORT1 SP4T(A170009)
Public Const SP4T_PORT3 As Long = 2                      ' PORT1 SP4T(A170009)
Public Const SP4T_PORT4 As Long = 3                      ' PORT1 SP4T(A170009)

Public Const DPDT_S11 As Long = 0                        ' S11 DPDT(A170010)
Public Const DPDT_S21 As Long = 1                        ' S21 DPDT(A170010)
Public Const DPDT_S22 As Long = 2                        ' S22 DPDT(A170010)
Public Const DPDT_S12 As Long = 3                        ' S12 DPDT(A170010)

Public Const McrMeas_AR As Integer = 0                   ' R3755A A/R
Public Const McrMeas__A As Integer = 1                   '       A
Public Const McrMeas__R As Integer = 2                   '       R
Public Const McrMeasS21 As Integer = 3                   ' R3760 S21
Public Const McrMeasS11 As Integer = 4                   '      S11
Public Const McrMeasS12 As Integer = 5                   '      S12
Public Const McrMeasS22 As Integer = 6                   '      S22

Public Const McrGetName As Integer = 0
Public Const McrGetNo As Integer = 1
'*****************************************************
'  Memory Trace Saved Key word.
'*****************************************************
Public Const MTRC_NOT_SAVE As Integer = 0               'Memory Trace Not Saved flag.
Public Const MTRC_SAVE  As Integer = 1                  'Memory Trace Saved flag.
'*****************************************************
'  Memory Trace Display Key word.
'*****************************************************
Public Const MTRC_NOT_DISP As Integer = 0               'Memory Trace Not Display flag.
Public Const MTRC_DISPLAY  As Integer = 1               'Memory Trace Display flag.
'*****************************************************
'  Memory Trace Display format Key word.
'*****************************************************
Public Const FMT_LOGMAG As Integer = 0
Public Const FMT_PHASE  As Integer = 1
Public Const FMT_LINMAG As Integer = 2
Public Const FMT_REAL   As Integer = 3
Public Const FMT_IMAG   As Integer = 4
Public Const FMT_UPHASE As Integer = 5
Public Const FMT_DELAY  As Integer = 6
Public Const FMT_SWR    As Integer = 7
'*****************************************************
'  Compensate ON/OFF Key word.
'*****************************************************
Public Const COMPENSATE_OFF As Integer = 0              'Compensate OFF
Public Const COMPENSATE_ON  As Integer = 1              'Compensate ON
'*****************************************************
'  Zero Span Key word.
'*****************************************************
Public Const NOT_ZERO_SPAN As Integer = 0               'Not Zero Span
Public Const ZERO_SPAN  As Integer = 1                  'Zero Span
'*****************************************************
'  Marker list display Key word.
'*****************************************************
Public Const MKR_LIST_OFF As Integer = 0                'Not display
Public Const MKR_LIST__ON As Integer = 1                'Display

Public Const WAIT_MESSAGE_01 As String = "Please wait until the sweep."


'****************************
' Calibration condition
'****************************
Public Const DEV_ORS_Index As Integer = 0              ' OPEN Rs
Public Const DEV_OLS_Index As Integer = 1              ' OPEN Ls
Public Const DEV_OCP_Index As Integer = 2              ' OPEN Cp
Public Const DEV_SRS_Index As Integer = 3              ' SHORT Rs
Public Const DEV_SLS_Index As Integer = 4              ' SHORT Ls
Public Const DEV_SCP_Index As Integer = 5              ' SHORT Cp
Public Const DEV_LRS_Index As Integer = 6              ' LOAD Rs
Public Const DEV_LLS_Index As Integer = 7              ' LOAD Ls
Public Const DEV_LCP_Index As Integer = 8              ' LOAD Cp

'****************************
' Xtal Measurement condition
'****************************
Public Const DEV_C0C_Index As Integer = 0              ' C0 CENTER
Public Const DEV_C0S_Index As Integer = 1              ' C0 SPAN
Public Const DEV_C0P_Index As Integer = 2              ' C0 POINTS
Public Const DEV_C0L_Index As Integer = 3              ' C0 Level of drive
Public Const DEV_C0R_Index As Integer = 4              ' C0 RBW
Public Const DEV_C0T_Index As Integer = 5              ' C0 Settling Time
Public Const DEV_OTC_Index As Integer = 6              ' other CENTER
Public Const DEV_OTS_Index As Integer = 7              ' other SPAN
Public Const DEV_OTP_Index As Integer = 8              ' other POINTS
Public Const DEV_OTL_Index As Integer = 9              ' other Level of drive
Public Const DEV_OTR_Index As Integer = 10             ' other RBW
Public Const DEV_OTT_Index As Integer = 11             ' other Settling Time
Public Const DEV_FLC_Index As Integer = 12             ' FL CENTER
Public Const DEV_FLS_Index As Integer = 13             ' FL SPAN
Public Const DEV_FLP_Index As Integer = 14             ' FL POINTS
Public Const DEV_FLL_Index As Integer = 15             ' FL Level of drive
Public Const DEV_FLR_Index As Integer = 16             ' FL RBW
Public Const DEV_FLT_Index As Integer = 17             ' FL Settling Time
Public Const DEV_CAC_Index As Integer = 18             ' Cal CENTER
Public Const DEV_CAS_Index As Integer = 19             ' Cal SPAN
Public Const DEV_CAP_Index As Integer = 20             ' Cal POINTS
Public Const DEV_CAL_Index As Integer = 21             ' Cal Level of drive
Public Const DEV_CAR_Index As Integer = 22             ' Cal RBW
Public Const DEV_CAT_Index As Integer = 23             ' Cal Settling Time

'*************************
' Xtal Measurement result
'*************************
Public Const TITL_C0_Index As Integer = 3              ' Title C0
Public Const TITL_C1_Index As Integer = 4              ' Title C1
Public Const TITL_L1_Index As Integer = 5              ' Title L1
Public Const TITL_R1_Index As Integer = 6              ' Title R1
Public Const TITL_Q__Index As Integer = 7              ' Title Q
Public Const TITL_Fr_Index As Integer = 8              ' Title Fr
Public Const TITL_CI_Index As Integer = 9              ' Title CI
Public Const TITL_FL_Index As Integer = 10             ' Title FL

Public Const RSLT_C0_Index As Integer = 11             ' result C0
Public Const RSLT_C1_Index As Integer = 12             ' result C1
Public Const RSLT_L1_Index As Integer = 13             ' result L1
Public Const RSLT_R1_Index As Integer = 14             ' result R1
Public Const RSLT_Q__Index As Integer = 15             ' result Q
Public Const RSLT_Fr_Index As Integer = 16             ' result Fr
Public Const RSLT_CI_Index As Integer = 17             ' result CI
Public Const RSLT_FL_Index As Integer = 18             ' result FL

Public Const UNIT_C0_Index As Integer = 19             ' UNIT C0
Public Const UNIT_C1_Index As Integer = 20             ' UNIT C1
Public Const UNIT_L1_Index As Integer = 21             ' UNIT L1
Public Const UNIT_R1_Index As Integer = 22             ' UNIT R1
Public Const UNIT_Q__Index As Integer = 23             ' UNIT Q
Public Const UNIT_Fr_Index As Integer = 24             ' UNIT Fr
Public Const UNIT_CI_Index As Integer = 25             ' UNIT CI
Public Const UNIT_FL_Index As Integer = 26             ' UNIT FL

'*******************************
' Xtal Measurement result Limit
'*******************************
Public Const LMT_C0_Index As Integer = 0                ' Limit index C0
Public Const LMT_C1_Index As Integer = 1                ' Limit index C1
Public Const LMT_L1_Index As Integer = 2                ' Limit index L1
Public Const LMT_R1_Index As Integer = 3                ' Limit index R1
Public Const LMT_Q__Index As Integer = 4                ' Limit index Q
Public Const LMT_Fr_Index As Integer = 5                ' Limit index Fr
Public Const LMT_CI_Index As Integer = 6                ' Limit index CI
Public Const LMT_FL_Index As Integer = 7                ' Limit index FL

'*****************************************************
'  Product Name key word.
'*****************************************************
Public Const PN_R3760__ As String = "R3760"             ' R3760
Public Const PN_R3755__ As String = "R3755"             ' R3755
Public Const PN_R3755A_ As String = "R3755A"            ' R3755A
Public Const PN_R3755TF As String = "R3755TF"           ' R3755TF
Public Const PN_R3755E_ As String = "R3755E"            ' R3755E

